#include <allegro.h>
#include "input.h"

bool ButtonAPrev;
bool ButtonACur;

bool ButtonEscapePrev;
bool ButtonEscapeCur;

bool ButtonUpPrev;
bool ButtonUpCur;

bool ButtonDownPrev;
bool ButtonDownCur;

void InitInput(void)
{
     install_keyboard();
     ButtonACur = false;
     ButtonEscapeCur = false;
     ButtonUpCur = false;
     ButtonDownCur = false;
     UpdateInput();
}

void DestroyInput(void)
{
     remove_keyboard();
}

void UpdateInput()
{
     poll_keyboard();
     ButtonAPrev = ButtonACur;
     
     //UpdateButtonACur.
     if(key[KEY_SPACE])
     {
         ButtonACur = true;
     }
     else if(key[KEY_ENTER])
     {
          ButtonACur = true;
     }
     else if(key[KEY_LSHIFT])
     {
          ButtonACur = true;
     }
     else if(key[KEY_RSHIFT])
     {
          ButtonACur = true;
     }
     else if(key[KEY_LCONTROL])
     {
          ButtonACur = true;
     }
     else if(key[KEY_RCONTROL])
     {
          ButtonACur = true;
     }
     else
     {
          ButtonACur = false;
     }
     
     ButtonEscapePrev = ButtonEscapeCur;
     //Escape button
     if(key[KEY_ESC])
     {
         ButtonEscapeCur = true;
     }
     else
     {
         ButtonEscapeCur = false;
     }
     
     ButtonUpPrev = ButtonUpCur;
     //Up button
     if(key[KEY_UP])
     {
         ButtonUpCur = true;
     }
     else if(key[KEY_W])
     {
          ButtonUpCur = true;
     }
     else if(key[KEY_8_PAD])
     {
          ButtonUpCur = true;
     }
     else
     {
         ButtonUpCur = false;
     }
     
     ButtonDownPrev = ButtonDownCur;
     //Down button
     if(key[KEY_DOWN])
     {
         ButtonDownCur = true;
     }
     else if(key[KEY_S])
     {
          ButtonDownCur = true;
     }
     else if(key[KEY_2_PAD])
     {
          ButtonUpCur = true;
     }
     else
     {
         ButtonDownCur = false;
     }
}

bool ButtonADown(void)
{
     return (ButtonACur == true && ButtonAPrev == false);
}

bool ButtonAUp(void)
{
     return (ButtonACur == false && ButtonAPrev == true);
}

bool ButtonAPressed(void)
{
     return ButtonACur;
}

bool ButtonEscapeDown(void)
{
     return (ButtonEscapeCur == true && ButtonEscapePrev == false);
}

bool ButtonEscapeUp(void)
{
     return (ButtonEscapeCur == false && ButtonEscapePrev == true);
}

bool ButtonEscapePressed(void)
{
     return ButtonEscapeCur;
}

bool ButtonUpDown(void)
{
     return (ButtonUpCur == true && ButtonUpPrev == false);
}

bool ButtonUpUp(void)
{
     return (ButtonUpCur == false && ButtonUpPrev == true);
}

bool ButtonUpPressed(void)
{
     return ButtonUpCur;
}

bool ButtonDownDown(void)
{
     return (ButtonDownCur == true && ButtonDownPrev == false);
}

bool ButtonDownUp(void)
{
     return (ButtonDownCur == false && ButtonDownPrev == true);
}

bool ButtonDownPressed(void)
{
     return ButtonDownCur;
}

void ResetInput(void)
{
     ButtonACur = false;
     ButtonEscapeCur = false;
     ButtonUpCur = false;
     ButtonDownCur = false;
     
     ButtonAPrev = false;
     ButtonEscapePrev = false;
     ButtonUpPrev = false;
     ButtonDownPrev = false;
}
