#include <allegro.h>
#include "menu.h"
#include "graphics.h"
#include "input.h"
#include "sprite.h"
#include "alfont/alfont.h"

int DisplayMainMenu(int unlockedMAttack, int unlockedSAttack)
{
    SPRITE header;
    ALFONT_FONT *menuFont;
    const int textX = 320;
    int Selection = 0;
    
    char *newGameText = "NEW GAME";
    char *quitText = "QUIT";
    char *marioAttackText;
    char *spinAttackText;
    
    if(unlockedMAttack)
    {
        marioAttackText = "MARIO ATTACK";
    }
    else
    {
        marioAttackText = "????? ??????";
    }
    
    if(unlockedSAttack)
    {
         spinAttackText = "SPIN ATTACK";              
    }
    else
    {
        spinAttackText = "???? ??????";
    }
    
    header.LoadImage("logo.bmp");
    menuFont = alfont_load_font("carbon.ttf");
    alfont_set_font_size(menuFont,36);
    
    bool selectionMade = false;
     while(!ButtonEscapeDown() && !selectionMade)
     {
          ClearScreen(0,0,0);
          header.DisplayXY(320 - (header.GetWidth() / 2), 120);
          
          //Unput Handling
          if(ButtonDownDown())
          {
              Selection++;    
              
              if(Selection > 3)
              {
                  Selection = 3;
              }
              
             if(Selection == 1 && !unlockedMAttack)
             {
                 Selection++;
             }
             
             if(Selection == 2 && !unlockedSAttack)
             {
                 Selection++;
             }
             
          }
          if(ButtonUpDown())
          {
             Selection--;
             
             if(Selection < 0)
                 Selection = 0;
                 
             if(Selection == 2 && !unlockedSAttack)
             {
                 Selection--;
             }
                 
             if(Selection == 1 && !unlockedMAttack)
             {
                 Selection--;
             }            
          }
          if(ButtonADown())
          {
              selectionMade = true;
          }
          
          if(Selection == 0)
               alfont_textout_centre_aa(back_buffer, menuFont, newGameText, textX, 260, makecol(200, 200, 255));    
          else
               alfont_textout_centre_aa(back_buffer, menuFont, newGameText, textX, 260, makecol(120, 120, 120));
               
          if(Selection == 1)     
               alfont_textout_centre_aa(back_buffer, menuFont, marioAttackText, textX, 300, makecol(200, 200, 255));   
          else
               alfont_textout_centre_aa(back_buffer, menuFont, marioAttackText, textX, 300, makecol(120, 120, 120));
               
          if(Selection == 2)
               alfont_textout_centre_aa(back_buffer, menuFont, spinAttackText, textX, 340, makecol(200, 200, 255));   
          else
               alfont_textout_centre_aa(back_buffer, menuFont, spinAttackText, textX, 340, makecol(120, 120, 120));
               
          if(Selection == 3)
               alfont_textout_centre_aa(back_buffer, menuFont, quitText, textX, 380, makecol(200, 200, 255));                  
          else
               alfont_textout_centre_aa(back_buffer, menuFont, quitText, textX, 380, makecol(120, 120, 120));              
               
          FlipScreen();                      
     }
     
     header.DestroyImage();
     alfont_destroy_font(menuFont);
     
     UpdateInput();  
     
     if(selectionMade == false)
     {
         return 3;
     }
     return Selection;
}
