#include <allegro.h>
#include "graphics.h"
#include "input.h"
#include "stopdisk.h"

void STOPDISK::LoadArt(void)
{
     MINIGAME::LoadArt();
     disk.LoadImage("disk.bmp");
     arrow.LoadImage("arrow.bmp");
     click.LoadSound("click.mp3");
}

void STOPDISK::ReleaseArt(void)
{
     disk.DestroyImage();
     arrow.DestroyImage();
     click.DestroySound();
     MINIGAME::ReleaseArt();
}

void STOPDISK::DisplayTimer()
{
     alfont_textprintf_ex(back_buffer, standardFont, 10, 10, makecol(255, 255, 255), makecol(0, 0, 0), "TIME: %d", gameTimer.GetValueFloor());
}

bool STOPDISK::PlayGame(int Difficulty)
{
     
     DisplayGoal("STOP THE DISK!!!");
     
     gameTimer.SetValue(1000);
     gameTimer.SetUPS(-150 - (Difficulty * 3));
     gameTimer.AddToProcessingList();
     rotation.SetValue(0);
     double rotationChange = 150 + (Difficulty * 7);
     if(rotationChange > 500)
          rotationChange = 500;
     rotation.SetUPS(150 + rotationChange);
     rotation.AddToProcessingList();
     bool rotating = true;
     bool winner = false;
     
     while(!ButtonEscapeUp() && gameTimer.GetValueFloor() > 0)
     {
         ClearScreen(0, 0, 0);
         DisplayTimer();
         disk.DisplayRotatedXY(240 - (disk.GetWidth() / 2), 240 - (disk.GetHeight() / 2), rotation.GetValueFloor());
         if(ButtonADown())
         {
             if(rotating==true)
             {
                 if(rotation.GetValueFloor() > 255-8 || rotation.GetValueFloor() < 14)
                 {
                     winner = true;
                 }         
                 click.PlaySound();
             }             
             rotation.RemoveFromProcessingList();
             rotating = false;
             gameTimer.SetUPS(-915);
         }
         if(rotation.GetValueFloor() >= 255)
         {
             rotation.SetValue(rotation.GetValue() - 255);
         }
         if(rotating)
            arrow.DisplayMaskedXY(400, 240 - arrow.GetHeight() /2);
         else
            arrow.DisplayMaskedXY(380, 240 - arrow.GetHeight() /2);
         FlipScreen();  
     }
     
     rotation.RemoveFromProcessingList();
     gameTimer.RemoveFromProcessingList();
     return winner;
}
