#include <allegro.h>
#include "timer.h"

unsigned int gameClock;
unsigned int prevFlipTime;
unsigned int curFlipTime;
unsigned int fps;
unsigned int currframe;

void UpdateGameClock(void)
{
     gameClock++;
}

void UpdateFPS(void)
{
     fps = currframe;
     currframe = 0;
}

void InitTimer(void)
{
     prevFlipTime = 0;
     curFlipTime = 0;
     gameClock = 0;
     fps = 0;
     install_timer();
     install_int(UpdateGameClock, 1);
     install_int_ex(UpdateFPS, SECS_TO_TIMER(1));
}

void DestroyTimer(void)
{
     remove_timer();
}

unsigned int GetFPS(void)
{
         return fps;
}

void UpdateTimeInfoAfterScreenFlip(void)
{
     prevFlipTime = curFlipTime;
     curFlipTime = gameClock;
     
     //If the timer ever starts over.
     if(curFlipTime < prevFlipTime)
     {
        prevFlipTime = 0;
     }
     currframe++;
}
  
unsigned int FrameTimeMS(void)
{
         return curFlipTime - prevFlipTime;
}

double FrameTime(void)
{
       return ((double)((double)curFlipTime - (double)prevFlipTime) / 1000.0);
}         
